// CalendarGregorian.cpp: implementation of the CCalendarGregorian class.
//
//////////////////////////////////////////////////////////////////////

#include "CalendarGregorian.h"
#include <cstring>
#include <cstdio>

string CCalendarGregorian::m_strNames[] = {
    "January", 
    "February",
    "March",
    "April",
    "May",
    "June",
    "July",
    "August",
    "September",
    "October",
    "November",
    "December"
};

int CCalendarGregorian::m_nLengths[] = {
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};

CCalendarGregorian* CCalendarGregorian::m_pInstance = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCalendarGregorian::CCalendarGregorian()
{
}

CCalendarGregorian::~CCalendarGregorian()
{
}

int CCalendarGregorian::getFirstMonth()
{
	return JANUARY;
}

int CCalendarGregorian::getLastMonth()
{
	return DECEMBER;
}

int CCalendarGregorian::getMonthLength(int nMonth)
{
	return m_nLengths[nMonth];
}

string CCalendarGregorian::getMonthName(int nMonth)
{
	return m_strNames[nMonth];
}

string CCalendarGregorian::getHoliday(int nDay, int nMonth)
{
	string strRtn;

	switch (nMonth) {
	case JANUARY : 
		if (nDay == 1) 
			strRtn = "New Years (s)";
		if (nDay == 6) 
			strRtn = "Twelfth Night";
		break;
	case FEBRUARY : 
		if (nDay == 2) 
			strRtn = "Candlemas";
		if (nDay == 14) 
			strRtn = "St. Valentine's Day";
		break;
	case MARCH : 
		if (nDay == 21) 
			strRtn = "Spring Equinox";
		break;
	case APRIL : 
		break;
	case MAY : 
		if (nDay == 1) 
			strRtn = "May Day";
		break;
	case JUNE : 
		if (nDay == 21) 
			strRtn = "Midsummer Day";
		break;
	case JULY : 
		break;
	case AUGUST : 
		if (nDay == 2) 
			strRtn = "Lammas";
		break;
	case SEPTEMBER : 
		if (nDay == 21) 
			strRtn = "Fall Equinox";
		break;
	case OCTOBER : 
		if (nDay == 31) 
			strRtn = "Halloween";
		break;
	case NOVEMBER : 
		break;
	case DECEMBER : 
		if (nDay == 21) 
			strRtn = "Winter Solstice";
		if (nDay == 25) 
			strRtn = "Christmas";
		break;
	}
	return strRtn;
}

CCalendarGregorian* CCalendarGregorian::instance()
{
	if (!m_pInstance)
	{
		m_pInstance = new CCalendarGregorian();
	}
	return m_pInstance;
}
