// CalendarMiddleEarth.cpp: implementation of the CCalendarMiddleEarth class.
//
//////////////////////////////////////////////////////////////////////

#include "CalendarMiddleEarth.h"
#include <cstring>
#include <cstdio>

string CCalendarMiddleEarth::m_strNames[] = {
    "Afteryule",
    "Solmath",
    "Rethe",
    "Astron",
    "Thrimidge",
    "Forelithe",
    "Afterlithe",
    "Wedmath",
    "Halimath",
    "Winterfilth",
    "Blotmath",
    "Foreyule",
};

int CCalendarMiddleEarth::m_nLengths[] = {
	30, 30, 30, 30, 30, 31, 30, 30, 30, 30, 30, 34
};

CCalendarMiddleEarth* CCalendarMiddleEarth::m_pInstance = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCalendarMiddleEarth::CCalendarMiddleEarth()
{
}

CCalendarMiddleEarth::~CCalendarMiddleEarth()
{
}

int CCalendarMiddleEarth::getFirstMonth()
{
	return AFTERYULE;
}

int CCalendarMiddleEarth::getLastMonth()
{
	return FOREYULE;
}

int CCalendarMiddleEarth::getMonthLength(int nMonth)
{
	return m_nLengths[nMonth];
}

string CCalendarMiddleEarth::getMonthName(int nMonth)
{
	return m_strNames[nMonth];
}

string CCalendarMiddleEarth::getHoliday(int nDay, int nMonth)
{
	string strRtn;
     switch (nMonth) {
     case AFTERYULE:
         break;
     case SOLMATH:
         break;
     case RETHE:
         break;
     case ASTRON:
         break;
     case THRIMIDGE:
         break;
     case FORELITHE:
         if (nDay == 31) 
			strRtn = " Midsummer Day (not in Forelithe)";
         break;
     case AFTERLITHE:
         break;
     case WEDMATH:
         break;
     case HALIMATH:
         break;
     case WINTERFILTH:
         break;
     case BLOTMATH:
         break;
     case FOREYULE:
         if ((nDay >= 31) && (nDay <= 34))
			strRtn = " Yule (not in ForeYule)";
         break;
     }
	 return strRtn;
}

CCalendarMiddleEarth* CCalendarMiddleEarth::instance()
{
	if (!m_pInstance)
	{
		m_pInstance = new CCalendarMiddleEarth();
	}
	return m_pInstance;
}
