// ClimateNPacific.cpp: implementation of the CClimateNPacific class.
//
//////////////////////////////////////////////////////////////////////

#include <cstddef>

#include "ClimateNPacific.h"

int CClimateNPacific::m_nAveTemp[] = {40, 50, 60, 65, 70, 80, 85, 75, 65, 50, 40, 35};

int CClimateNPacific::m_nWeatherTable[12][4] = {
    {10,15,0,100}, {35,45,0,100}, {50,70,0,100}, {50,70,0,100}, {50,60,0,100}, {50,60,0,100}, 
    {35,40,0,100}, {40,45,47,100}, {40,45,47,100}, {10,15,16,100}, {10,15,0,100}, {10,15,0,100}
};

int CClimateNPacific::m_nWindTable[12][5] = {
    {40,70,90,100,0}, {40,70,90,100,0}, {40,70,90,100,0}, {40,70,90,100,0}, {40,70,90,100,0}, {40,70,90,100,0}, 
    {40,70,90,100,0}, {40,70,90,100,0}, {40,70,90,100,0}, {40,70,90,100,0}, {40,70,90,100,0}, {40,70,90,100,0}
};

int CClimateNPacific::m_nPrecipTable[12][5] = {
    {0,40,70,80,100},
    {0,50,80,95,100},
    {0,60,80,100,0},
    {0,40,70,90,100},
    {0,50,80,100,0},
    {0,60,90,100,0},
    {0,80,95,100,0},
    {0,80,95,100,0},
    {0,60,80,90,100},
    {0,50,80,90,100},
    {0,40,70,85,100},
    {0,40,70,80,100}
};

int CClimateNPacific::m_nOvercastTable[] = {10,20,70,100};


CClimateNPacific* CClimateNPacific::m_pInstance = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClimateNPacific::CClimateNPacific()
{
}

CClimateNPacific::~CClimateNPacific()
{

}

int CClimateNPacific::getAveTemp(int nMonth)
{
	return m_nAveTemp[nMonth];
}

int CClimateNPacific::getWeather(int nMonth, int nTyp)
{
	return m_nWeatherTable[nMonth][nTyp];
}


int CClimateNPacific::getWind(int nMonth, int nTyp)
{
	return m_nWindTable[nMonth][nTyp];
}


int CClimateNPacific::getPrecip(int nMonth, int nTyp)
{
	return m_nPrecipTable[nMonth][nTyp];
}


int CClimateNPacific::getOvercast(int nTyp)
{
	return m_nOvercastTable[nTyp];
}

CClimateNPacific* CClimateNPacific::instance()
{
	if (!m_pInstance)
	{
		m_pInstance = new CClimateNPacific();
	}
	return m_pInstance;
}
